               JOB  TAPE DEMONSTRATION
**********************************************************************
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     *
     PRTBUF    EQU  201       *START OF PRINT BUFFER
     PUNBUF    EQU  101       *START OF PUNCH BUFFER
     REDBUF    EQU  001       *START OF READ BUFFER
     *
               ORG  87
     X1        DCW  000       *INDEX REGISTER 1
               DCW  @X1@      *IDENTIFING FILLER
     X2        DCW  000       *INDEX REGISTER 2
               DCW  @X2@      *IDENTIFING FILLER
     X3        DCW  000       *INDEX REGISTER 3
               DCW  @X3@      *IDENTIFING FILLER
     *
               ORG  400       *ORG JUST AFTER PRINT BUFFER
     *
     IDENT     DCW  @TAPE INPUT OUTPUT PROGRAM VERSION 00 09/11/2012@ 
     GRPMRK    DCW  @"@       *DEFINE GROUP MARK
     SSCNT     DCW  @0@       *DEFINE SENSE SWITCH COUNT
     *
     *
     **********************************************************************
     *
     START     H                     *HALT AND WAIT FOR THE OPERATOR
             
               dcW  @M%y1401@
               H
     START2    NOP
               CS   332              *CLEAR 332 TO 300
               CS                    *CLEAR 299 TO 200
               CS                    *CLEAR 199 TO 100
               CS   080              *CLEAR 080 TO 000
               SW   201              *SET WORD MARK FOR PRINTING
               MCW  @0@,SSCNT
     *
               B    SWB,B            *BRANCE IF SS B IS ON
               B    TSSC             *BRANCH TO TEST SS C
     SWB       A    @1@,SSCNT        *ADD 1 TO SS COUNT
     *
     TSSC      B    SWC,C            *BRANCE IF SS C IS ON
               B    TSSD             *BRANCH TO TEST SS D
     SWC       A    @1@,SSCNT        *ADD 1 TO SS COUNT
     *
     TSSD      B    SWD,D            *BRANCE IF SS D IS ON
               B    TEXT             *BRANCH TO TEST SS E
     SWD       A    @1@,SSCNT        *ADD 1 TO SS COUNT
     *
     TEXT      BCE  RUN,SSCNT,1      *IF WE HAVE NO DRIVES OR TOO MANY
     *
     *****************************************************************
     *         HAD A PROBLEM SO PRINT INSTRUCTIONS
     *****************************************************************
     OOPS      MCW  @SENSE SWITCH ERROR. RESET AND TRY AGAIN@,250
               W
               CS   299                  *CLEAR PRINT STORAGE
     *
     *PRINT HEADING
     *         
               MCW  IDENT,247
               W
               CS   299
               MCW  @SENSE SWITCH B = TAPE 4 TO PRINTER       @,250 
               W
               CS   299      
               MCW  @SENSE SWITCH C = TAPE 4 TP PUNCH         @,250 
               W      
               CS   299           
               MCW  @SENSE SWITCH D = CARD READER TO TAPE 4   @,250 
               W  
               CS   299 
               CC   1                    *TOP OF FORM
               B    START                *HALT AND THEN START OVER
     *********************************************************
     *     RUN ###################################
     *********************************************************
     RUN       B    PRTTAP,B             *IF SS B, PRINT FROM TAPE
               B    PUNTAP,C             *IF SS C, PUNCH FROM TAPE
               B    REDTAP,D             *IF SS D, READ TO TAPE
               H    999,999              *JUST IN CASE
     ************************************************************
     *     PRINT FROM TAPE 4
     ************************************************************
     PRTTAP    RWD  4                   *REWIND TAPE 4
     PRT2      CS   333
               CS
               LCA  GRPMRK,333          *SET A GROUP MAKE WORD MARK 
               RT   4,PRTBUF            *READ A RECORD FROM TAPE 4
               BEF  PRTX                *BRANCH OF END OF FILE
               W                        *PRINT IT
               B    PRT2                *DO IT AGAIN
     PRTX      RWD  4
               B    DONE
     *
     ******************************************************
     *
     PUNTAP    RWD  4                   *REWIND TAPE 4
     PUN2      CS   181
               LCA  GRPMRK,181          *SET A GROUP MAKE WORD MARK 
               RT   4,PUNBUF            *READ A RECORD FROM TAPE 4
               BEF  PUNX                *BRANCH OF END OF FILE
               P                        *PUNCH IT
               B    PUN2                *DO IT AGAIN
     PUNX      RWD  4
               B    DONE
     *
     ******************************************************
     *
     REDTAP    RWD  4                   *REWIND TAPE 4
     RED2      CS   081                 *CLEAR STORAGE
               R                        *READ A CARD
               B    REDX,A              *BRANCH ON END OF DECK
               LCA  GRPMRK,081          *SET A GROUP MAKE WORD MARK 
               WT   4,REDBUF            *WRITE TAPE 4
               B    RED2                *DO IT AGAIN
     REDX      RWD  4
               B    DONE
     *
     ******************************************************
     *
     *  WE ARE DONE
     *
     DONE      CS   332
               CS
               CC   1                  *TOP OF FORMS
     DONE2     NOP  999,999
               H                       *HALT BEFORE GOING TO THE NEXT PROGRAM
               CS   332                *CLEAR UPPER PRINT BUFFER
               CS                      *CLEAR LOWER PRINT BUFFER
               CS                      *CLEAR PUNCH BUFFER
               CS                      *CLEAR READ BUFFER
               SW   001                *SET FIRST WM
     RDAG      R                       *READ A CARD
               BCE  GO,001,,           *IS IT A COMMA?
               B    RDAG               *BRANCH TO READ AGAIN
     GO        B    001                *GO TO THE CODE
               NOP                     *TRAILER WITH A WM
     *
     *************************************************
               END  START
