     ***************************************************************************
     *     SSSSS = CARD SEQUENCE NUMBER          ********** = LABEL
     *     OPER- = OPERATION                     OPERANDS--- = OPERATION
SSSSS**********OPER-OPERANDS----------------------------------------------------     **********|****|***********************************************************
               JOB  SECOND PROGRAM 80/80 CARD LISTER
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     *
     RDBUFF    EQU  1                   *READ BUFFER   (1-80)
     PUBUFF    EQU  101                 *PUNCH BUFFER  (101-181)
     PRBUFF    EQU  201                 *PRINT BUFFER  (201-332)
     *
     SEQNUM    EQU  003                 *CARD SEQUENCE NUMBER
     AORB      EQU  005                 *A OR B FLAG
     SEGMNT    EQU  007                 *1 OR B FLAG
     DATALF    EQU  013                 *LEFT SIDE OF DATA
     DATART    EQU  052                 *RIGHT HAND SIDE OF DATA 
     PRTLFT    EQU  260                 *LEFT SIDE OF DATA
     PRTRGH    EQU  300                 *RIGHT SIDE OF DATA
     *
               ORG  87
     X1        DCW  000                 *INDEX REGISTER 1
               DC   00
     X2        DCW  000                 *INDEX REGISTER 2
               DC   00
     X3        DCW  0000                *INDEX REGISTER 3
     *              
               ORG  340                 *START JUST ABOVE PRINT BUFFER
     PRTBUF    DS   132                 *SECOND LINE PRINT BUFFER
     *
               DCW  @MODEL PRINT PROGRAM 1/x/2009@
     LSTLIN    DCW  000                 *LAST LINE NUMBER
     LSTSEG    DCW  0                   *LAST SEGMENT NUMBER
     ENDFIL    DCW  999                 *END OF FILE
     *
     START     H                        *HALT FOR A GOOD RUNNING START
               CS   PRBUFF&132          *CLEAR THE PRINT BUFFER 332 TO 300
               CS                       *CLEAR THE PRINT BUFFER 299 TO 200
               SW   RDBUFF              *SET A WORD MARK AT THE BEGINNING
     *                                  * OF THE READ BUFFER
               SW   DATALF              *SET WORD MARK LEFT SIDE OF DATA FIELD
               MCW  @001@,LSTLIN        *SET LAST LINE TO THE FIRST CARD NUMBER
               MCW  @1@,LSTSEG          *SET LAST GEGMENT
     *
     READ      R                        *READ A CARD
               C    003,LSTLIN          *SAME LINE NUMBER?
               BE   SAMNUM              *SAME LINE NUMBER 
     *
     ***************************************************************
     * NEW SEQUENCE NUMBER SO PRINT BUFFER AND SPACE A LINE
     ***************************************************************
     *
               W                        *PRINT THE BUFFER
               C    332                 *CLEAR THE PRINT BUFFER
               C                        *CLEAR THE PRINT BUFFER
               MCW  SEQNUM,LSTLIN       *SET THE SEQUENCE NUMBER
               MCW  SEGMNT,LSTSEG       *SET THE SEGMENT NUMBER
               B    MOVLIN              *PROCESS THE DATA
     ***************************************************************
     SAMNUM    C    SEGMNT,LSTSEG       *SEE IF WE ARE ON THE SAME SEGMENT
               BE   MOVLIN              *GO TO MOVE LINE IF EQUAL
     *
     ***************************************************************
     * NEW SEGMENT NUMBER SO PRINT BUFFER AND SUPRESS SPACE A LINE
     ***************************************************************
     *
               W                        *PRINT THE BUFFER
               DC   @S@                 *SUPRESS SPACE
               C    332                 *CLEAR THE PRINT BUFFER
               C                        *CLEAR THE PRINT BUFFER
               MCW  SEGMNT,LSTSEG       *SET THE SEGMENT NUMBER
               B    MOVLIN              *PROCESS THE DATA
     ***************************************************************
     MOVLIN    C    SEQNUM,ENDFIL       *SEE IF AT END OF FILE
               BE   EXIT                *EXIT IF AT END
               BCE  AREC,AORB,A         *IS IT AN A?
               BCE  BREC,AORB,B         *IS IT A  B?
               B    READ                *DEFAULT
     AREC      MCW  DATART,PRTLFT       *PUT IT IN THE LEFT BUFFER
               B    READ                *GO GET ANOTHER ONE
     BREC      MCW  DATART,PRTRGH       *PUT IT IN THE RIGHT BUFFER
               B    READ                *GO GET ANOTHER ONE
     *
     EXIT      W                        *PRINT THE LAST LINE
               CC   1                   *FORM FEED
               H
     *
               CS   332                 *CLEAR PRINT BUFFER
               CS                       *CLEAR PRINT BUFFER
               CS                       *CLEAR PUNCH BUFFER
               CS                       *CLEAR READ BUFFER
               SW   001                 *SET A WORD MAKE IN THE FIRST POSITION
               R                        *READ THE NEXT CARD
               B    001                 *BRANCH TO IT          
               NOP                      *
               END  START
