               JOB  TAPE DEMONSTRATION
**********************************************************************
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     *
     TSIZE     EQU  004       *SIZE OF TAPE RECORD TO WRITE
     *
               ORG  87
     X1        DCW  000       *INDEX REGISTER 1
               DCW  @X1@      *IDENTIFING FILLER
     X2        DCW  000       *INDEX REGISTER 2
               DCW  @X2@      *IDENTIFING FILLER
     X3        DCW  000       *INDEX REGISTER 3
               DCW  @X3@      *IDENTIFING FILLER
     *
               ORG  340       *ORG JUST AFTER PRINT BUFFER
     *               123456789012345678901234567890123
     IDENT     DCW  @*TAPE TEST PRGM VER 1 05/17/2011 @ 
     GRPMRK    DCW  @"@       *DEFINE GROUP MARK
     TPEBUF    DCW  @A@       *FIRST CHARACTER OF TAPE BUFFER
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
     TBEND     DC   @1234567890@
               DCW  @"@                  * GROUPMARK
     *
     *
     **********************************************************************
     *
     START     NOP  111,111          *PUT A VALUE IN A AND B
               H                     *HALT AND WAIT FOR THE OPERATOR
     START2    NOP
               CS   332              *CLEAR 332 TO 300
               CS                    *CLEAR 299 TO 200
               CS                    *CLEAR 199 TO 100
               CS   080              *CLEAR 080 TO 000
               SW   201              *SET WORD MARK FOR PRINTING
     *
     *PRINT HEADING
     *         
               MCW  IDENT,247
               W
               CS   299
               B    RWTAP       *REWIND TAPE
               DCW  @1@         *TAPE DRIVE NUMBER 1 
               DCW  @U@         *ODD PARITY 
     RWSTAT    DCW  @ @         *0 = REWIND STATUS 0=OK  1 = ERROR
     RWNOP     NOP              *RETURN FROM CALL
               BCE  WRTTAP,RWSTAT,0     *GO ON IF OK
               MCW  @REWIND ERROR@,230
               W
               W
               W
               H    *-3
     *LETS GO WRITE A TAAPE RECORD
               B    WRTTAP
               DCW  @1@          *TAPE DRIVE NUMBER 1
               DCW  @U@
               DSA  TPEBUF      *THE HIGH ORDER ADDRESS OF THE BUFFER
               DCW  @800@        *LENGTH OF RECORD
               DCW  @ @          *0 = WRITE OK   
     *                           *1 = NO GMWM AT ADDRESS + LEN + 1
     *                           *2 = UNRECOVERABLE WRITE ERROR
     *                           *3 = RECOVERABLE READ ERROR   
     *
     *  WE ARE DONE
     *
     *DONE      
     *
     *      B        RRDTAP
     *DRV  DCW  @1@          *TAPE DRIVE NUMBER 1 - 6
     *PAR        DCW        @U@          *ODD PARITY B IS EVEN PARITY
     *ADD  DSA  @XXX@    *THE HIGH ORDER ADDRESS OF THE BUFFER
     *LEN  DCW  @800@        *LENGTH OF RECORD
     *STAT DCW  @0@          *0 = READ OK   
     *  *1 = NO GMWM AT ADDRESS + LEN + 1
     *2 = UNRECOVERABLE READ ERROR
     *3 = RECOVERABLE READ ERROR
     *        B        WRTTAP
     *DRV  DCW  @1@          *TAPE DRIVE NUMBER 1 - 6
     *PAR        DCW        @U@          *ODD PARITY B IS EVEN PARITY
     *ADD  DSA  @XXX@    *THE HIGH ORDER ADDRESS OF THE BUFFER
     *LEN  DCW  @800@        *LENGTH OF RECORD
     *STAT DCW  @0@          *0 = WRITE OK   
     *  *1 = NO GMWM AT ADDRESS + LEN + 1
     * *2 = UNRECOVERABLE WRITE ERROR
     *3 = RECOVERABLE READ ERROR
     *        B        BKTAP
     *DRV  DCW  @1@          *TAPE DRIVE NUMBER 1 - 6
     *PAR        DCW        @U@          *ODD PARITY B IS EVEN PARITY
     *STAT DCW  @0@          *0 = BACKSPACE OK   
     *1 = ERROR
     *        B        SABTAP
     *DRV  DCW  @1@          *TAPE DRIVE NUMBER 1 - 6
     *PAR        DCW        @U@          *ODD PARITY B IS EVEN PARITY
     *STAT DCW  @0@          *0 = SKIP AND BLANK  OK   
     *1 = ERROR
     *     *        B        RWTAP
     *DRV  DCW  @1@          *TAPE DRIVE NUMBER 1 - 6
     *PAR        DCW        @U@          *ODD PARITY B IS EVEN PARITY
     *STAT DCW  @0@          *0 = REWIND AND UNLOAD OK   
     *1 = ERROR
     *        B        RWTAP
     *DRV  DCW  @1@          *TAPE DRIVE NUMBER 1 - 6
     *PAR        DCW        @U@          *ODD PARITY B IS EVEN PARITY
     *STAT DCW  @0@          *0 = REWIND OK   
     *1 = ERROR
     *****************************************************************
               END  START
