               JOB  TAPE DEMONSTRATION
**********************************************************************
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     *
     *
     *
               ORG  87
     X1        DCW  000       *INDEX REGISTER 1
               DCW  @X1@      *IDENTIFING FILLER
     X2        DCW  000       *INDEX REGISTER 2
               DCW  @X2@      *IDENTIFING FILLER
     X3        DCW  000       *INDEX REGISTER 3
               DCW  @X3@      *IDENTIFING FILLER
     *
               ORG  340       *ORG JUST AFTER PRINT BUFFER
     *
     IDENT     DCW  @TAPE TEST PRGM VER 2 05/17/2013 @ 
     IDENT2    DCW  @TESTING TAPE ON TAPE DRIVE 1    @
     *
     GRPMRK    DCW  @"@       *DEFINE GROUP MARK
     *
     TBUFF     DCW  @A@       *FIRST CHARACTER OF TAPE BUFFER
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
               DC   @1234567890A@
               DC   @BCDEFGHIJKLMNOPQRSTUVWXYZ@
     TBEND     DC   @1234567890@
               DCW  @"@                  * GROUPMARK
     RECS      DCW  @0500@
     COUNT     DCW  @0000@
     WERR      DCW  @0000@
     RERR      DCW  @0000@
     *
     *
     **********************************************************************
     *
     START     H                     *HALT AND WAIT FOR THE OPERATOR
               CS   332              *CLEAR 332 TO 300
               CS                    *CLEAR 299 TO 200
               CS                    *CLEAR 199 TO 100
               CS   080              *CLEAR 080 TO 000
     *
     *PRINT HEADING
     *         
               MCW  IDENT,247
               W
               CS   299
               MCW  IDENT2,247
               W
               CS   299
               W
               MCW  @0000@,COUNT
               MCW  COUNT,WERR
               MCW  COUNT,RERR
               RWD  1                   *REWIND TAPE 1
     WT1       WT   1,TBUFF             *WRITE THE TAPE RECORD 
               A    @1@,COUNT           *COUNT RECORDS WRITTEN
               B    TWERR,L              *TAPE ERROR?
     WTS       C    RECS,COUNT
               BL   WT1                 *LETS DO SOME MORE
               B    RETST
     TWERR     A    @1@,WERR            *ADD 1 TO WRITE ERROR COUNT
               B    WTS    
     RETST     MCW  @0000@,COUNT
               RWD  1                   *REWIND TAPE 1
     RT1       RT   1,TBUFF             *READ THE TAPE RECORD 
               A    @1@,COUNT           *COUNT RECORDS
               B    TERR,L              *TAPE ERROR?
     RTS       C    RECS,COUNT
               BL   RT1                 *LETS DO SOME MORE
               B    DONE                *DONE WITH TEST
     TERR      A    @1@,TERR            *ADD 1 TO READ ERROR COUNT
               B    RTS    
     DONE      RWD  1                   *REWIND TAPE 1
               MCW  @RECORDS PROCESSED @,220
               MCW  RECS,225
               W
               MCW  @WRITE ERRORS      @,220
               MCW  WERR,225
               W
               MCW  @READ ERRORS       @,220
               MCW  RERR,225
               W
               CS   299
               CC   1
               B    START
               NOP
               END  START
