               HEAD
     
     **********PASSED PARAMETERS  *************************************
     PCMD      DCW  @ @     * 1=SETUP, 2=SET, 3=CLEAR, 4= PRINT PAGE
     PWHO      DCW  @ @     * X OR O (O AS IN OHIO)
     PWHR      DCW  @ @     * 1 TO 9
     PRTN      DCW  @ @     * 0 = OK, ANYTHING ELSE - BAD
     *****************************************************************


     TESTY     DCW  00                  *ARE WE ON THE SAME LINE?
     YREG      DCW  00                  *WHEN WE WANT AN Y VALUE
     XREG      DCW  00                  *WHEN WE WANT AN X VALUE
     XREG2     DCW  00                  *WHEN WE WANT AN X VALUE
     BASE      DCW  000                 *BASE OF TABLE
     THREE     DCW  000                 *MAP A TWO DIGIT TO THREE DIGIT
     PGBASE    DCW  000                 *BASE FOR XM OR O PLACEMENT
     X         DCW  @X@
     ZE        DCW  @0@
     COUNT     DCW  00
               STACK                    *STACK USED BY KALL AND RETRN
               DCW  @************XXX STARTS HERE******@
     XXX       DA   13X24,X3            * PRINT AN X
               DCW  @************XXX ENDS HERE********@      
     
               DCW  @************PAGE STARTS HERE******@
     PAGE      DA   50X106                      * PRINT BUFFER
               DCW  @************PAGE ENDS HERE******@

     
     START     H
               MCW  @1@,PCMD            *SET UP THE PAGE
               KALL PAGE0
     
               MCW  @2@,PCMD            *SET an x or o
               MCW  @X@,PWHO            *SET AS X
               MCW  @1@,PWHR            *SET TO SQUARE 1
               KALL PAGE0
      
               MCW  @2@,PWHR            *SET TO SQUARE 2
               KALL PAGE0
     
               MCW  @3@,PWHR            *SET TO SQUARE 3
               KALL PAGE0
      
               MCW  @4@,PWHR            *SET TO SQUARE 4
               KALL PAGE0
     
               MCW  @5@,PWHR            *SET TO SQUARE 5
               KALL PAGE0
     
               MCW  @6@,PWHR            *SET TO SQUARE 6
               KALL PAGE0
     
               MCW  @o@,PWHO            *SET AS o
               MCW  @7@,PWHR            *SET TO SQUARE 7
               KALL PAGE0
     
               MCW  @8@,PWHR            *SET TO SQUARE 8
               KALL PAGE0
     
               MCW  @9@,PWHR            *SET TO SQUARE 9 
               KALL PAGE0
     
               MCW  @4@,PCMD            *PRINT THE PAGE
               KALL PAGE0
               B    START
     
     ***************************************************
     *client code above this line
     *server code below this line
     ***************************************************
                
     PAGE0     C    @0@,PCMD
               BH   PAGE1               *OK SO FAR
               MCW  @1@,PRTN            *BAD BOY
               RETRN                    *GO BACK
     PAGE1     C    @5@,PCMD            *CHECK FOR LESS THAN 5
               BL   PAGE2               *OK 
               MCW  @1@,PRTN            *BAD BOY
               RETRN                    *GO BACK
     PAGE2     BCE  SETUP, PCMD,1       *IS IT A SETUP?
               BCE  SETONE,PCMD,2       *DO WE NEED TO SET A SQUARE?
               BCE  PRTTBL,PCMD,4       *IS IT A PRINT REQUEST
               RETRN                    *GO BACK
     
     *********************************************************
     * SETUP ROUTINE
     *********************************************************
     SETUP     SBR  X1,ZEROIN+1         *PICK UP THE ADDRESS OF THE TABLE
               MCW  @00@,TESTY          *PICK UP THE FIRST Y
               MCW  @000@,X2            *SET  X2 TO ZERO
               MCW  X2,BASE             *STARTING POINT
              
     LOOP1     MCW  1+X1,YREG           *PICK UP THE Y
               MCW  3+X1,XREG           *PICK UP THE X
               MCW  5+X1,XREG2          *PICK UP THE X
               MA   @006@,X1
              
     LOOP2     C    YREG,@99@           *ARE WE DONE?
               BE   LOOPX
               MN   XREG,X2
               MN   XREG-1,X2-1
               MCW  @M@,210+X2
               MCW  @M@,211+X2
               MCW  @M@,212+X2
               MN   XREG2,X2 
               
               MCW  234,ZERO+23
               MA   @024@,X3
               CS   299
               MCW  YREG,TESTY
               MN   XREG2-1,X2-1
               MCW  @M@,210+X2
               MCW  @M@,211+X2
               MCW  @M@,212+X2

               B    LOOP1               *TRY AGAIN
     LOOPX     NOP
               MCW  @000@,X3
    
               
               SBR  X1,XIN+1            *PICK UP THE ADDRESS OF THE TABLE
               MCW  @00@,TESTY          *PICK UP THE FIRST Y
               MCW  @000@,X2            *SET  X2 TO ZERO
               MCW  @000@,X3            *SET  X3 TO ZERO
              
     XOOP1     MCW  1+X1,YREG           *PICK UP THE Y
               MCW  3+X1,XREG           *PICK UP THE X1
               MCW  5+X1,XREG2          *PICK UP THE X2
               
               
               MA   @006@,X1
               C    YREG,TESTY          *ARE WE ON THE SAME LINE?
               BE   XOOP2
               MCW  TESTY,203
               W
               MCW  233,XXX+23
               MA   @024@,X3
               CS   299
               MCW  YREG,TESTY
     XOOP2     C    YREG,@99@           *ARE WE DONE?
               BE   XOOPX
     
               MN   XREG,X2
               MN   XREG-1,X2-1
               MCW  @M@,210+X2
               MCW  @M@,211+X2
               MCW  @M@,212+X2
     
               MN   XREG2,X2
               MN   XREG2-1,X2-1
               MCW  @M@,210+X2
               MCW  @M@,211+X2
               MCW  @M@,212+X2

               B    XOOP1               *TRY AGAIN
     XOOPX     NOP
               MCW  @00@,COUNT
               MCW  @000@,X3
          
               KALL CLEAR           *CLEAR THE OUTPUT
               RETRN                *GO BACK



     **************************************************
     *   ROUTINE TO PUT AN X OR AN O IN A SQUARE
     **************************************************
     SETONE    BCE  ITISOK,PWHO,X     *IS IT AN X?
               BCE  ITISOK,PWHO,O     *IS IT AN O?
               MCW  @2@,PRTN         *RETURN A BAD CODE
               RETRN                 *GO BACK
     ITISOK    C    @0@,PWHR         *SEE IF 1-9 
               BH   SOL2             *LOOKS GOOD TO ME
               MCW  @3@,PRTN         *RETURN A BAD CODE
               RETRN                 *GO BACK
     *         DON'T HAVE TO CHECK THE HIGH END BECAUSE 9 IS THE 
     *         HIGHEST CHARACTER IS THE COLLATING SEQUENCE

     SOL2      ZA   PWHR,THREE       *MOVE IT TO A 3 DIGIT PLACE
               S    @1@, THREE       *ZERO BASE THE NUMBER
               MZ   THREE-1,THREE    *KILL ZONE IF SET
               MCW  @000@,X1         *ZERO X1
               MA   THREE,X1         *ADD THREE TIMES
               MA   THREE,X1         *ADD THREE TIMES
               MA   THREE,X1         *ADD THREE TIMES
               MCW  INSPTS+X1,X2     *PUT THE LOCATIONS FROM THE TABLE IN X2
               mcw  x2,x1            *put it back in x1
               mcw  @022@,x3         *right end of zero line or xxx line
     *
     *         X1 POINTS into THE POSITION ON THE PAGE TO PUT THE DATA
     *         X3 POINTS inTO THE X OR O ARRAY
     *         
               MCW  @00@,COUNT         *ZERO COUNT
     *          mcw  @s@,page+X1           *TST
              
     SOL3      BCE  ITISX,PWHO,X     *IS IT AN X?
               BCE  ITISO,PWHO,O     *IS IT AN O?
     itisx     MCW  xxx,PAGE+x1
     *          mcw  @hi shay@,PAGE+x1
               b    sol4              *go on
     itisO     MCW  zero,PAGE+x1
     *          mcw  @hi shay@,PAGE+x1
     sol4      MA   @106@,X1           *NEXT LINE ON PAGE
               MA   @024@,X3           *NEXT LINE IN PATTERN
               A    @1@,COUNT          *INCREMENT COUNT
               C    @13@,COUNT         *ARE WE THere YET?
               BL   SOL3              *NO, NOT YET

               MCW  @0@,PRTN         *RETURN A GOOD CODE
               RETRN                 *GO BACK
    


     **************************************************
     *ROUTINE TO CLEAR THE OUTPUT BUFFER AND DRAW LINES
     **************************************************
     CLEAR     SBR  X3,PAGE+105      *END OF FIRST LINE
               MCW  @00@,COUNT       *RESET COUNT
     CLEAR1    MCW  VDIVD,0+X3       *MOVE THE LINE
               MA   @106@,X3         *POINT TO NEXT LINE
               A    @01@,COUNT       *ADD 1 TO COUNT      
               C    @50@,COUNT       *SEE IF WE ARE DONE
               BL   CLEAR1           *DO IT SOME MORE      
               SBR  X3,PAGE+1589     *END OF 14TH LINE LINE
               MCW  HDIVD,0+X3       *MOVE THE LINE
               MA   @106@,X3         *POINT TO NEXT LINE
               MCW  HDIVD,0+X3       *MOVE THE LINE
               SBR  X3,PAGE+3285     *END OF 28TH LINE LINE
               MCW  HDIVD,0+X3       *MOVE THE LINE
               MA   @106@,X3         *POINT TO NEXT LINE
               MCW  HDIVD,0+X3       *MOVE THE LINE
               MCW  @0@,PRTN         *RETURN A GOOD CODE
               RETRN                 *GO BACK

     
          
              
     *********************************************
     * PRINT TABLE
     *********************************************
     PRTTBL    SBR  X3,PAGE+105    *END OF FIRST LINE
               MCW  @00@,COUNT     *RESET COUNT 
     PRTBAR    MCW  0+X3,306       *MOVE A LINE TO PRINT
               A    @01@,COUNT     *COUNT IT
               MCW  COUNT,203      *KEEP TRACK
               W
               MA   @106@,X3       *KICK UP THE LOCTION
               C    @045@,COUNT    *HAVE WE DONE 50
               BL   PRTBAR         *GO GET ANOTER ONE
               CC   1              *GO TO TOP OF FORM
               MCW  @0@,PRTN       *SAY OK
               RETRN               *GO BACK


     EXIT      EXIT
    
     ********** THE FOLLOWING DEFINES A NORMAL LINE ******
               DCW  @                         @   *MARGIN 25 SPACES
               DC   @                         @   *25 SPACES
               DC   @XXX@                         *THREE XS
               DC   @                         @   *25 SPACES
               DC   @XXX@                         *THREE XS
     VDIVD     DC   @                         @   *25 SPACES TOTAL OF 106


     ********** THE FOLLOWING DEFINES A LINE CONTAINING HORZONAL DIVIDERS **
               DCW  @                         @   *MARGIN 25 SPACES
               DCW  @OOOOOOOOOOOOOOOOOOOOOOO00@   *25
               DC   @OOOOOOOOOOOOOOOOOOOOOOOOO@   *25 
               DC   @OOOOOOOOOOOOOOOOOOOOOOOOO@   *25 
     HDIVD     DC   @OOOOOO@                      *6 TOTAL OF 106


               DCW  @************ZERO STARTS HERE******@
     ZERO      DA   13X24,X3           * PRINT A ZERO
               DCW  @************ZERO ENDS HERE********@ 

  
    
     * THE FOLLOWING TABLE IS Y-X PAIRS FOR A CIRCLE WHEN PRINTED
     * THE PAIRS ARE TERMINATED BY 99 99
     * WHEN USING, YOU CAN ADD +1 AND THEN +2 TO EACH X VALUE TO 
     * GIVE THE HEAVER X
     * OR ALSO ADD +1 AND +2 TO THE Y VALUE.


     ZEROIN    DCW  @Z@
               DC   001015
               DC   010718
               DC   020420
               DC   030321
               DC   040122
               DC   050122
               DC   060022
               DC   070022
               DC   080122
               DC   090221
               DC   100419
               DC   110618
               DC   121411
               DC   999999

     * THE FOLLOWING TABLE IS Y-X PAIRS FOR A SINGLE X
     * WHEN USING, YOU CAN ADD +1 AND THEN +2 TO EACH X VALUE TO 
     * GIVE THE HEAVER X
     * OR ALSO ADD +1 AND +2 TO THE Y VALUE.

     XIN       DCW  @X@
               DC   000023
               DC   010221
               DC   020419
               DC   030518
               DC   040716
               DC   050914
               DC   061112
               DC   071211
               DC   081409
               DC   091607
               DC   101805
               DC   111904
               DC   122102
               DC   132300
               DC   999999
     * INSERTION POINTS FOR X AND O
     INSPTS    DSA   048
               DSA   076
               DSA   104
               DSA   1744
               DSA   1772
               DSA   1800
               DSA   3440
               DSA   3468
               DSA   3496
              
 
               END  START
