     ***************************************************************************
     *     SSSSS = CARD SEQUENCE NUMBER          ********** = LABEL
     *     OPER- = OPERATION                     OPERATION--- = OPERATION
SSSSS**********OPER-OPERANDS----------------------------------------------------     **********|****|***********************************************************
               JOB  FIRST PROGRAM
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     PRINT     EQU  201
               ORG  87
     X1        DCW  000                 *INDEX REGISTER 1
               DCW  11
     X2        DCW  000                 *INDEX REGISTER 2
               DCW  22
     X3        DCW  000                 *INDEX REGISTER 3
               DCW  33
               ORG  340
     *
               DCW  @IBM 1401 PROGRAM 10/23/2008@
     STEPR     DSA  3                   *ADD 3 TO INDEX
     STEPL     DSA  15997               *ROLL OVER -3
     NEXT      DCW  @000@               *IF SENSE SWITCHES ARE NOT USED
     LPCNT     DCW  88                  *COUNT LOOPS
     I         DCW  00                  *GENERAL INDEX
     CHM       DCW  @COMPUTER HISTORY MUSEUM@  *FILLER FOR PRINT TEST
     *
     START     H
               CS   332                 *CLEAR 332 TO 300
               CS                       *CLEAR 299 TO 200
               CS                       *CLEAR 199 TO 100
               CS                       *CLEAR 099 T0 000
               SW   101                 *SET A WORD MARK AT THE BEGINNING
     *                                  *OF THE PRINT FIELD
     TEST      B    RDDEMO,B            *DO THE READ DEMO
               B    PUDEMO,C            *DO THE PUNCH DEMO
               B    RPDEMO,D            *DO THE READ PUNCH DEMO
               B    PRDEMO,E            *DO PRINT DEMO
               A    @010@,NEXT          *INCREMENT NEXT
               B    RESET,NEXT-1,5      *SEE IF WE ARE OVER 40
               B    RDDEMO,NEXT-1,1     *IF 10 READ DEDEMO
               B    PUDEMO,NEXT-1,2     *IF 20 PUNCH DEDEMO
               B    RPDEMO,NEXT-1,3     *IF 30 READ AND PUNCH DEMO
               B    PRDEMO,NEXT-1,4     *IF 40 PRINT DEMO
               H                        *SHOULD NOT BE HERE
     RESET     ZA   @000@,NEXT          *RESET TO ZERO
               B    TEST                *GO BACK AND TRY AGAIN 
     RDDEMO    ZA   @00@,LPCNT          *SET THE LOOP COUNTER TO ZERO
     RD2       R                        *READ A CARD
               A    @01@,LPCNT          *INCREMENT LOOP COUNT
               B    START,LPCNT-1,2     *IF YOU READ 20, GO BACK TO TOP
               B    RD2                 *GO DO ANTOHER ONE
     *
     PUDEMO    ZA   @00@,LPCNT          *SET THE LOOP COUNTER TO ZERO
     PD2       P                        *PUNCH A CARD
               A    @01@,LPCNT          *INCREMENT LOOP COUNT
               B    START,LPCNT-1,1     *IF YOU PUNCHED 10, GO BACK TO TOP
               B    PD2                 *GO DO ANTOHER ONE
     RPDEMO    ZA   @00@,LPCNT          *SET THE LOOP COUNTER TO ZERO
     RPD2      R                        *READ A CARD
     *         SS   NR                  *GOES INTO NORMAL READ STACKER
               R                        *READ A CARD
               SS   1                   *SELECT READ STACKER 2
               R                        *READ A CARD
               SS   2                   *SELECT READ STACKER 3
               P                        *PUNCH  A CARD
     *         SS   NP                  *GOES INTO NORMAL PUNCH STACKER
               P                        *PUNCH  A CARD
               SS   4                   *SELECT PUNCH STACKER 2
               P                        *PUNCH  A CARD
               SS   8                   *SELECT PUNCH STACKER 3
               A    @01@,LPCNT          *INCREMENT LOOP COUNT
               B    START,LPCNT-1,1     *IF YOU READ 10, GO BACK TO TOP
               B    RPD2                *GO DO ANTOHER ONE
     *
     PRDEMO    ZA   @04@,LPCNT          *SET THE LOOP COUNTER TO FOUR
     *                                  *SO LPTCNT-1 = 4 AFTER 36 LOOPS
               MCW  @022@,X1            *SET THE LEFT OFFSET
               MCW  @131@,X2            *SET THE RIGHT OFFSET
     PRD2      CS   332                 *CLEAR PRINT BUFFER
               CS                       *THE REST
               MCW  CHM,PRINT&X1        *PUT THE LEFT IN
               MCW  CHM,PRINT&77        *MIDDLE
               MCW  CHM,PRINT&X2        *PUT IN THE RIGHT
               W                        *PRINT IT
               A    @01@,LPCNT          *COUNT THE LINES
               B    PRDX,LPCNT-1,4      *LOOK FOR 4X
     *
               MA   STEPR,X1            *INCREMENT X1 BY 3
               MA   STEPL,X2            *ADD 16000 -3 TO X2
               B    PRD2                *DO THAT AGAIN
     PRDX      CC   1                   *GO TO HEAD OF FORM
               B    START               *GO BACK TO TOP
               END  START
