     ***************************************************************************
     *     SSSSS = CARD SEQUENCE NUMBER          ********** = LABEL
     *     OPER- = OPERATION                     OPERANDS--- = OPERATION
SSSSS**********OPER-OPERANDS----------------------------------------------------     **********|****|***********************************************************
               JOB  FIRST PROGRAM
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     *
     RDBUFF    EQU  1                   *READ BUFFER   (1-80)
     PUBUFF    EQU  101                 *PUNCH BUFFER  (101-181)
     PRBUFF    EQU  201                 *PRINT BUFFER  (201-332) 
     *
               ORG  87
     X1        DCW  000                 *INDEX REGISTER 1
               DC   00
     X2        DCW  000                 *INDEX REGISTER 2
               DC   00
     X3        DCW  0000                *INDEX REGISTER 3
     *              
               ORG  15500
     *
     MYDATA    DCW  @THIS IS MY PATCH PROGRAM  10/31/2010@      *DATA TO PRINT
     TEST      DCW  @S@
     T900      DCW  @00900@
     *
     START     H
               SW   RDBUFF
               SW   RDBUFF&5
               SW   RDBUFF&6
               MCW  @000@,X1            *CLEAR X1
               CS   PRBUFF&132          *CLEAR 332 TO 300 
               CS                       *CLEAR 299 TO 200
               CS                       *CLEAR 199 TO 100
               MCW  MYDATA,PRBUFF&25    *MOVE TAIL END OF MY DATA IN 25 LOCATIONS
               W                        *PRINT IT
     NEXT      MCW  @000@,X1
               R                        *READ A PATCH CARD
               C    RDBUFF&3,@(GO)@     *ARE WE DONE?
               BE   GOPRG               *GO TO PTOGRAM
     CKSIZE    C    T900,RDBUFF&4       *COMPARE ADDRESS WITH 900
               BL   LT900               *IT IS LESS THAN 900
               S    T900,RDBUFF&4      *SUBTRACT 900 FROM ADDRESS
               MZ   RDBUFF&3,RDBUFF&4   *KILL ZONE BITS
               MA   @900@,X1            *ADD 900 TO X1
               B    CKSIZE
     **********************************
     LT900     MA   RDBUFF&4,X1
               MCW  0&X1,TEST           *CURRENT CHARACTER
               C    TEST,RDBUFF&5       *IS IT THE SAME?
               BU   OOPS                *IF ERROR
               MCW  RDBUFF&6,0&X1
               B    NEXT
     OOPS      MCW  @AT ADDRESS 123456 THE CHARACTER IS X AND SHOULD BE X
     *               123456789012345678901234567890123456789012345678901234567890
               MCW  RDBUFF&4,PRBUFF&16
               MCW  TEST,PRBUFF&35
               MCW  RDBUFF&5,PRBUFF&51
               W
               B    NEXT
     GOPRG     CW   RDBUFF&5
               CW   RDBUFF&6
               SW   RDBUFF&4
     CKSZ2     C    T900,RDBUFF&8       *COMPARE ADDRESS WITH 900
               BL   LT9002              *IT IS LESS THAN 900
               S    T900,RDBUFF&8       *SUBTRACT 900 FROM ADDRESS
               MZ   RDBUFF&7,RDBUFF&8   *KILL ZONE BITS
               MA   @900@,X1            *ADD 900 TO X1
               B    CKSZ2               *LETS GO GET THE NEXT 900
     LT9002    MA   RDBUFF&8,X1         *LOAD THE LESS THAN 900 VALUE INTO X1
               B    0&X1                *THIS IS MAGIC
     **********************************
               NOP
               END  START
